; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; ADC initialisieren mit "Free Run" und Vorteiler								
;																				
; 	ADEN: ADC Enable                             								
; 	ADSC: ADC Start Conversion                   								
; 	ADFR: ADC Free Running Select                								
; 	ADIF: ADC Interrzpt Flag                     								
; 	ADIE: ADC Interrupt Enable                   								
; 	ADPS2: Vorteiler                             								
; 	ADPS2: Vorteiler                             								
; 	ADPS2: Vorteiler                             								
;																				
;	ADPS2 ADPS1 ADPS0 Division Factor											
;	0 		0 	0 		2														
;	0 		0 	1 		2														
;	0 		1 	0 		4														
;	0 		1 	1 		8														
;	1 		0 	0 		16														
;	1 		0 	1	 	32														
; *	1 		1 	0 		64														
;	1 		1 	1 		128														
;																				
; ADC REFERENZ																	
; REFS1 REFS0 Voltage Reference Selection										
;  0     0    AREF, Internal Vref turned off									
;  0     1    AVCC with external capacitor at AREF pin							
; *1     1    Internal 2.56V Voltage Reference with external capacitor at AREF pin
;																				
ADC_INITIALISIERUNG_2_56V:
	ldi temp, ((1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(1<<ADPS2)|(1<<ADPS1)|(0<<ADPS0)) 
	out ADCSR, temp

	ldi temp, (1<<REFS1)|(1<<REFS0)
	out ADMUX, temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ADC_RECHTS:
	in temp, ADMUX
	andi temp, 0b11100000
	subi temp, 0			; KANAL 0	
	out ADMUX, temp

	rcall ADC_MAX_TEMP1_2	; OUT: TEMP1 / TEMP2	

	LSR temp2				; durch 2				
	ROR temp1
	LSR temp2				; durch 2				
	ROR temp1

	STS(adr_ADC_RE),NULL	; Null		
	cpi temp1,127
	brlo ADC0_EXIT

	subi temp1,127			; -127		
	STS(adr_ADC_RE),temp1	; save					

ADC0_EXIT:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; linker-KANAL																	
ADC_LINKS:
	in temp, ADMUX
	andi temp, 0b11100000
	subi temp, -1			; KANAL 1	
	out ADMUX, temp

	rcall ADC_MAX_TEMP1_2	; OUT: TEMP1 / TEMP2	

	LSR temp2				; durch 2	
	ROR temp1
	LSR temp2				; durch 2	
	ROR temp1


	STS(adr_ADC_LI),NULL	; Null		
	cpi temp1,127
	brlo ADC1_EXIT


	subi temp1,127			; -127		
	STS(adr_ADC_LI),temp1	; save		

ADC1_EXIT:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ADC_FAST_TEMP1_2:
;-------------------------------------------------------------------------------
; neuen ADC-Wert lesen	 Wert verwerfen, da meist vom vorherigem ADC-Kanal		
	sbi ADCSRA, ADIF    		; logisch "1" lscht ADIF flag !	
ADC_FAST_w:                  
	sbis ADCSRA, ADIF			; warten bis ADIF flag gesetzt		
	rjmp ADC_FAST_w
;-------------------------------------------------------------------------------
ADC_FAST_w1:                
	sbis ADCSR, ADIF 			; warten bis ADIF flag gesetzt		
	rjmp ADC_FAST_w1                
;-------------------------------------------------------------------------------
; ADC einlesen:																	
	in  temp1, ADCL 			; immer zuerst LOW Byte lesen
	in  temp2, ADCH 			; danach das mittlerweile gesperrte High Byte
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ADC-WERT 256 mal einlesen und daraus den Mittelwert bilden					
;																				
; OUT: 	TEMP1 (low)  															
;		TEMP2																	
; 																				
ADC_MAX_TEMP1_2:
	clr temp3			; max(L)										
	clr temp4			; max(H)										
	ldi temp9,10		; SCHLEIFE initialisieren						
;-------------------------------------------------------------------------------
; neuen ADC-Wert lesen	 Wert verwerfen, da meist vom vorherigem ADC-Kanal		
	sbi ADCSRA, ADIF    ; logisch "1" lscht ADIF flag !				
ADC_MAX_w:                  
	sbis ADCSRA, ADIF	; warten bis ADIF flag gesetzt					
	rjmp ADC_MAX_w
;-------------------------------------------------------------------------------
; neuen ADC-Wert lesen	(Schleife - 256 mal)									
ADC_MAX_s:                
	sbi ADCSRA, ADIF    ; logisch "1" lscht ADIF flag !				
ADC_MAX_w2:                
	sbis ADCSR, ADIF 	; warten bis ADIF flag gesetzt					
	rjmp ADC_MAX_w2
;-------------------------------------------------------------------------------
; ADC einlesen:																	
	in  temp1, ADCL 	; immer zuerst LOW Byte lesen					
	in  temp2, ADCH 	; danach das mittlerweile gesperrte High Byte	
;-------------------------------------------------------------------------------
; Vergleich																		
	cp temp2,temp4		; Vergleich high								
	breq ADC_MAX_L
	brsh ADC_MAX_SAVE
	brlo ADC_MAX_EXIT
ADC_MAX_L:
	cp temp1,temp3		; Vergleich low									
	breq ADC_MAX_SAVE
	brsh ADC_MAX_SAVE
	brlo ADC_MAX_EXIT
ADC_MAX_SAVE:
	mov temp3,temp1
	mov temp4,temp2
ADC_MAX_EXIT:
	dec temp9			; Schleifenzhler MINUS 1						
	brne ADC_MAX_s 		; ==> SCHLEIFE									
;-------------------------------------------------------------------------------
	mov temp1,temp3
	mov temp2,temp4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
