; ##############################################################################
; ##############################################################################
; ##############################################################################
STARTWERTE:
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; COUNTER			
	ldi temp,10
	STS(adr_COUNTER),temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
WDR_INITIALISIERUNG:
	ldi TEMP,(1<<WDCE)|(1<<WDE) ; Watchdog aktivieren (max. Zeit)				
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (SRAM_START)
	ldi ZH, HIGH(SRAM_START)
	ldi temp,0
;-------------------------------------------------------------------------------
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PORT_INITIALISIERUNG:
; auf Eingang				
	clr temp
	out DDRB, temp	
	out DDRC, temp
	out DDRD, temp
	out PORTB,temp				
	out PORTC,temp				
	out PORTD,temp
;-------------------------------------------------------------------------------
; auf Ausgang				
	sbi (L0_DDR),(L0_PIN_NR)		; L0
	sbi (R0_DDR),(R0_PIN_NR)		; R0
	sbi (L1_DDR),(L1_PIN_NR)		; L1
	sbi (R1_DDR),(R1_PIN_NR)		; R1
	sbi (L2_DDR),(L2_PIN_NR)		; L2
	sbi (R2_DDR),(R2_PIN_NR)		; R2
	sbi (L3_DDR),(L3_PIN_NR)		; L3
	sbi (R3_DDR),(R3_PIN_NR)		; R3
	sbi (L4_DDR),(L4_PIN_NR)		; L4
	sbi (R4_DDR),(R4_PIN_NR)		; R4
	sbi (L5_DDR),(L5_PIN_NR)		; L5
	sbi (R5_DDR),(R5_PIN_NR)		; R5
	sbi (L6_DDR),(L6_PIN_NR)		; L6
	sbi (R6_DDR),(R6_PIN_NR)		; R6
	sbi (L7_DDR),(L7_PIN_NR)		; L7
	sbi (R7_DDR),(R7_PIN_NR)		; R7
	sbi (L8_DDR),(L8_PIN_NR)		; L8
	sbi (R8_DDR),(R8_PIN_NR)		; R8
	sbi (L9_DDR),(L9_PIN_NR)		; L9
	sbi (R9_DDR),(R9_PIN_NR)		; R9
;-------------------------------------------------------------------------------
	L0_ON
	R0_ON
	rcall WAIT_10ms
	L1_ON
	R1_ON
	rcall WAIT_10ms
	L2_ON
	R2_ON
	rcall WAIT_10ms
	L3_ON
	R3_ON
	rcall WAIT_10ms
	L4_ON
	R4_ON
	rcall WAIT_10ms
	L5_ON
	R5_ON
	rcall WAIT_10ms
	L6_ON
	R6_ON
	rcall WAIT_10ms
	L7_ON
	R7_ON
	rcall WAIT_10ms
	L8_ON
	R8_ON
	rcall WAIT_10ms
	L9_ON
	R9_ON
	rcall WAIT_100ms
;-------------------------------------------------------------------------------
	L0_OFF
	R0_OFF
	L1_OFF
	R1_OFF
	L2_OFF
	R2_OFF
	L3_OFF
	R3_OFF
	L4_OFF
	R4_OFF
	L5_OFF
	R5_OFF
	L6_OFF
	R6_OFF
	L7_OFF
	R7_OFF
	L8_OFF
	R8_OFF
	L9_OFF
	R9_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_ERROR
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_ERROR
	; VOLL		
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_ERROR
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_ERROR
	ret
;-------------------------------------------------------------------------------
PROGRAMM_CHECK_ERROR:
	CLI 										; Global Interrupt Disable
	rcall wait_100ms

	rcall wait_100ms

	rjmp PROGRAMM_CHECK_ERROR
; ##############################################################################
; ##############################################################################
; ##############################################################################
