;												
; Pegelanzeige 2x10 LED fr ATmega8				
; Bernhard.Erfurt@gmx.de						
; 08/2023										
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> LED-
; PB1 ==> LED-
; PB2 ==> LED-
; PB3 ==> LED-
; PB4 ==> LED-
; PB5 ==> LED-
; PB6 ==> LED-
; PB7 ==> LED-
;												
; PC0 ==> ADC0									
; PC1 ==> ADC1									
; PC2 ==> LED-
; PC3 ==> LED-
; PC4 ==> LED-
; PC5 ==> LED-
;												
; PD0 ==> LED-
; PD1 ==> LED-
; PD2 ==> LED-
; PD3 ==> LED-
; PD4 ==> LED-
; PD5 ==> LED-
; PD6 ==> LED-
; PD7 ==> LED-
;												


; ATmega8 										
.include "m8def.inc"
.include "MACRO.asm"
; LED-L0										
.equ L0_PIN_NR						= 0
.equ L0_DDR							= DDRD
.equ L0_PORT						= PORTD
; LED-L1										
.equ L1_PIN_NR						= 5
.equ L1_DDR							= DDRC
.equ L1_PORT						= PORTC
; LED-L2										
.equ L2_PIN_NR						= 4
.equ L2_DDR							= DDRC
.equ L2_PORT						= PORTC
; LED-L3										
.equ L3_PIN_NR						= 3
.equ L3_DDR							= DDRC
.equ L3_PORT						= PORTC
; LED-L4										
.equ L4_PIN_NR						= 2
.equ L4_DDR							= DDRC
.equ L4_PORT						= PORTC
; LED-L5										
.equ L5_PIN_NR						= 5
.equ L5_DDR							= DDRB
.equ L5_PORT						= PORTB
; LED-L0										
.equ L6_PIN_NR						= 4
.equ L6_DDR							= DDRB
.equ L6_PORT						= PORTB
; LED-L7										
.equ L7_PIN_NR						= 3
.equ L7_DDR							= DDRB
.equ L7_PORT						= PORTB
; LED-L8										
.equ L8_PIN_NR						= 2
.equ L8_DDR							= DDRB
.equ L8_PORT						= PORTB
; LED-L9										
.equ L9_PIN_NR						= 1
.equ L9_DDR							= DDRB
.equ L9_PORT						= PORTB

; LED-R0										
.equ R0_PIN_NR						= 1
.equ R0_DDR							= DDRD
.equ R0_PORT						= PORTD
; LED-R1										
.equ R1_PIN_NR						= 2
.equ R1_DDR							= DDRD
.equ R1_PORT						= PORTD
; LED-R2										
.equ R2_PIN_NR						= 3
.equ R2_DDR							= DDRD
.equ R2_PORT						= PORTD
; LED-R3										
.equ R3_PIN_NR						= 4
.equ R3_DDR							= DDRD
.equ R3_PORT						= PORTD
; LED-R4										
.equ R4_PIN_NR						= 6
.equ R4_DDR							= DDRB
.equ R4_PORT						= PORTB
; LED-R5										
.equ R5_PIN_NR						= 7
.equ R5_DDR							= DDRB
.equ R5_PORT						= PORTB
; LED-R6										
.equ R6_PIN_NR						= 5
.equ R6_DDR							= DDRD
.equ R6_PORT						= PORTD
; LED-R7										
.equ R7_PIN_NR						= 6
.equ R7_DDR							= DDRD
.equ R7_PORT						= PORTD
; LED-R8										
.equ R8_PIN_NR						= 7
.equ R8_DDR							= DDRD
.equ R8_PORT						= PORTD
; LED-R9										
.equ R9_PIN_NR						= 0
.equ R9_DDR							= DDRB
.equ R9_PORT						= PORTB




; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						=SRAM_START		; 0x0060 START Adresse 		

.equ adr_COUNTER					=SRAM_START+10	; Counter					

.equ adr_ADC_RE						=SRAM_START+40	; 8 Bit ADC					
.equ adr_ADC_LI						=SRAM_START+41	; 8 Bit ADC					

.equ adr_ADC_RE_MAX					=SRAM_START+50	; 8 Bit ADC					
.equ adr_ADC_LI_MAX					=SRAM_START+51	; 8 Bit ADC					

.equ adr_SRAM_CHECK					=SRAM_START+943	; SRAM CHECK muss immer "S" sein	
; REGISTER										
.def NULL 	= R12
.def EINS 	= R14
.def VOLL	= R15

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25


.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   ; Timer1 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   ;rjmp Timer0 Overflow Handler          
rjmp INTERRUPT_ERROR	;rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	
;-------------------------------------------------------------------------------
; Unkorrekten Interrupt Aufruf 													
INTERRUPT_ERROR:

	rcall wait_100ms

	rcall wait_100ms
	rjmp INTERRUPT_ERROR
;-------------------------------------------------------------------------------
RESET:                        
	ldi temp, LOW(RAMEND)					; STACK initialisieren								
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp

	rcall WDR_INITIALISIERUNG				; WDR_INITIALISIERUNG								
	rcall SRAM_CLEAR						; SRAM lschen										
	rcall PORT_INITIALISIERUNG				; PORT												
	rcall STARTWERTE						; Startwerte										
	rcall ADC_INITIALISIERUNG_2_56V			; ADC												
	rcall PROGRAMM_CHECK					; CHECK												
	sei										; Interrupts freigeben								
;-------------------------------------------------------------------------------
LOOP:
	WDR										; Watch-Dog-RESET	
	rcall ADC_RECHTS						; rechter KANAL		
	rcall ADC_LINKS							; linker  KANAL		
;-------------------------------------------------------------------------------
	LDS temp,(adr_COUNTER)					; load				
	dec temp								; -1				
	STS(adr_COUNTER),temp					; save				
	tst temp								; NULL?				
	brne LOOP_w								; nein				
	ldi temp,20
	STS(adr_COUNTER),temp					; save				
	rcall BERECHNUNG_LI_MAX
	rcall BERECHNUNG_RE_MAX
;-------------------------------------------------------------------------------
LOOP_w:
	rcall L_PEGEL
	rcall R_PEGEL

	rcall LI_PUNKT
	rcall RE_PUNKT

	rcall PROGRAMM_CHECK
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG_LI_MAX:
	LDS temp1,(adr_ADC_LI)
	LDS temp2,(adr_ADC_LI_MAX)
	cp temp1,temp2
	breq BERECHNUNG_LI_MAX_w1
	brsh BERECHNUNG_LI_MAX_w1
	brlo BERECHNUNG_LI_MAX_w2
BERECHNUNG_LI_MAX_w1:
	STS(adr_ADC_LI_MAX),temp1
	ret
;-------------------------------------------------------------------------------
BERECHNUNG_LI_MAX_w2:
	LDS temp,(adr_ADC_LI_MAX)
	dec temp
	tst temp
	breq BERECHNUNG_LI_MAX_EXIT
	STS(adr_ADC_LI_MAX),temp
BERECHNUNG_LI_MAX_EXIT:
	STS(adr_ADC_LI_MAX),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG_RE_MAX:
	LDS temp1,(adr_ADC_RE)
	LDS temp2,(adr_ADC_RE_MAX)
	cp temp1,temp2
	breq BERECHNUNG_RE_MAX_w1
	brsh BERECHNUNG_RE_MAX_w1
	brlo BERECHNUNG_RE_MAX_w2
BERECHNUNG_RE_MAX_w1:
	STS(adr_ADC_RE_MAX),temp1
	ret
;-------------------------------------------------------------------------------
BERECHNUNG_RE_MAX_w2:
	LDS temp,(adr_ADC_RE_MAX)
	dec temp
	tst temp
	breq BERECHNUNG_RE_MAX_EXIT
	STS(adr_ADC_RE_MAX),temp
BERECHNUNG_RE_MAX_EXIT:
	STS(adr_ADC_RE_MAX),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "ADC.asm"
.include "LED.asm"
.include "SONSTIGES.asm"
.include "WAIT.asm"

